package b4a.example;


import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
        processBA.runHook("oncreate", this, null);
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
        WaitForLayout wl = new WaitForLayout();
        if (anywheresoftware.b4a.objects.ServiceHelper.StarterHelper.startFromActivity(processBA, wl, false))
		    BA.handler.postDelayed(wl, 5);

	}
	static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.example.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (processBA.runHook("oncreateoptionsmenu", this, new Object[] {menu}))
            return true;
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
@Override
 public boolean onPrepareOptionsMenu(android.view.Menu menu) {
    super.onPrepareOptionsMenu(menu);
    processBA.runHook("onprepareoptionsmenu", this, new Object[] {menu});
    return true;
    
 }
 protected void onStart() {
    super.onStart();
    processBA.runHook("onstart", this, null);
}
 protected void onStop() {
    super.onStop();
    processBA.runHook("onstop", this, null);
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEventFromUI(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
        if (processBA.runHook("onkeydown", this, new Object[] {keyCode, event}))
            return true;
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
        if (processBA.runHook("onkeyup", this, new Object[] {keyCode, event}))
            return true;
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
        processBA.runHook("onnewintent", this, new Object[] {intent});
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        processBA.runHook("onpause", this, null);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
        processBA.runHook("ondestroy", this, null);
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
        processBA.runHook("onresume", this, null);
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
        processBA.runHook("onactivityresult", this, new Object[] {requestCode, resultCode});
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}
    public void onRequestPermissionsResult(int requestCode,
        String permissions[], int[] grantResults) {
        for (int i = 0;i < permissions.length;i++) {
            Object[] o = new Object[] {permissions[i], grantResults[i] == 0};
            processBA.raiseEventFromDifferentThread(null,null, 0, "activity_permissionresult", true, o);
        }
            
    }

public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.objects.Timer _tmrrecord = null;
public static boolean _b_busy = false;
public static int _i_buffersize = 0;
public static int _i_samplerate = 0;
public static int _i_channelconfig = 0;
public static int _i_audioformat = 0;
public static int _i_audiosource = 0;
public stevel05.audiorecord.AudioRecording _ar = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnrecord = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblfreq = null;
public anywheresoftware.b4a.objects.EditTextWrapper _txtinfo = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblpitch = null;
public anywheresoftware.b4a.objects.SpinnerWrapper _spnanalysers = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblcent = null;
public anywheresoftware.b4a.objects.SpinnerWrapper _spna = null;
public b4a.example.starter _starter = null;
public b4a.example.modtuner _modtuner = null;
public b4a.example.modfreqanalyser _modfreqanalyser = null;

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 40;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 42;BA.debugLine="Activity.LoadLayout(\"viewMain\")";
mostCurrent._activity.LoadLayout("viewMain",mostCurrent.activityBA);
 //BA.debugLineNum = 44;BA.debugLine="tmrRecord.Initialize(\"tmrRecord\", 250)";
_tmrrecord.Initialize(processBA,"tmrRecord",(long) (250));
 //BA.debugLineNum = 46;BA.debugLine="i_AudioSource = AR.A_Src_Mic";
_i_audiosource = mostCurrent._ar.A_SRC_MIC;
 //BA.debugLineNum = 47;BA.debugLine="i_SampleRate = 44100";
_i_samplerate = (int) (44100);
 //BA.debugLineNum = 48;BA.debugLine="i_ChannelConfig	= AR.Ch_Conf_Mono";
_i_channelconfig = mostCurrent._ar.CH_CONF_MONO;
 //BA.debugLineNum = 49;BA.debugLine="i_AudioFormat = AR.Af_PCM_16";
_i_audioformat = mostCurrent._ar.AF_PCM_16;
 //BA.debugLineNum = 50;BA.debugLine="i_BufferSize = 10000' 8192'10000";
_i_buffersize = (int) (10000);
 //BA.debugLineNum = 52;BA.debugLine="modTuner.Init(441)";
mostCurrent._modtuner._init(mostCurrent.activityBA,(int) (441));
 //BA.debugLineNum = 53;BA.debugLine="modTuner.FillAfreqVars(spnA)";
mostCurrent._modtuner._fillafreqvars(mostCurrent.activityBA,mostCurrent._spna);
 //BA.debugLineNum = 55;BA.debugLine="spnAnalysers.Add(\"Analyser 1\")";
mostCurrent._spnanalysers.Add("Analyser 1");
 //BA.debugLineNum = 56;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 62;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 64;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 58;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 60;BA.debugLine="End Sub";
return "";
}
public static String  _btnrecord_click() throws Exception{
 //BA.debugLineNum = 118;BA.debugLine="Sub btnRecord_Click";
 //BA.debugLineNum = 119;BA.debugLine="If btnRecord.Text = \"Start\" Then";
if ((mostCurrent._btnrecord.getText()).equals("Start")) { 
 //BA.debugLineNum = 120;BA.debugLine="btnRecord.Text = \"Stop\"";
mostCurrent._btnrecord.setText(BA.ObjectToCharSequence("Stop"));
 //BA.debugLineNum = 122;BA.debugLine="AR.Initialize(i_AudioSource, i_SampleRate, i_Cha";
mostCurrent._ar.Initialize(processBA,_i_audiosource,_i_samplerate,_i_channelconfig,_i_audioformat,_i_buffersize);
 //BA.debugLineNum = 123;BA.debugLine="AR.StartRecording";
mostCurrent._ar.StartRecording();
 //BA.debugLineNum = 124;BA.debugLine="tmrRecord.Enabled = True";
_tmrrecord.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 }else {
 //BA.debugLineNum = 126;BA.debugLine="btnRecord.Text = \"Start\"";
mostCurrent._btnrecord.setText(BA.ObjectToCharSequence("Start"));
 //BA.debugLineNum = 127;BA.debugLine="AR.Stop";
mostCurrent._ar.Stop();
 //BA.debugLineNum = 128;BA.debugLine="AR.release";
mostCurrent._ar.release();
 //BA.debugLineNum = 129;BA.debugLine="tmrRecord.Enabled = False";
_tmrrecord.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 };
 //BA.debugLineNum = 132;BA.debugLine="End Sub";
return "";
}
public static String  _frequenceanalyser1(short[] _sounddata) throws Exception{
int[] _iperiodes = null;
int _ibestcomp = 0;
int _ipos1 = 0;
int _ipos2 = 0;
int _iwl = 0;
int _icorr = 0;
int _ik = 0;
int _ipercount = 0;
double _dwl = 0;
double _dfreq = 0;
int _ipitchnr = 0;
 //BA.debugLineNum = 82;BA.debugLine="Sub FrequenceAnalyser1(sounddata() As Short)";
 //BA.debugLineNum = 83;BA.debugLine="Dim iPeriodes() As Int = modFreqAnalyser.GetPerio";
_iperiodes = mostCurrent._modfreqanalyser._getperiodes(mostCurrent.activityBA,_sounddata);
 //BA.debugLineNum = 84;BA.debugLine="If iPeriodes(0) > 0 Then 'kind of success";
if (_iperiodes[(int) (0)]>0) { 
 //BA.debugLineNum = 87;BA.debugLine="Dim iBestComp As Int = modFreqAnalyser.GetBestCo";
_ibestcomp = mostCurrent._modfreqanalyser._getbestcomparer(mostCurrent.activityBA,_iperiodes);
 //BA.debugLineNum = 88;BA.debugLine="If iBestComp >= 2 Then";
if (_ibestcomp>=2) { 
 //BA.debugLineNum = 89;BA.debugLine="Dim iPos1 As Int = iPeriodes(1) 'start position";
_ipos1 = _iperiodes[(int) (1)];
 //BA.debugLineNum = 90;BA.debugLine="Dim iPos2 As Int = iPeriodes(iBestComp)'start p";
_ipos2 = _iperiodes[_ibestcomp];
 //BA.debugLineNum = 91;BA.debugLine="Dim iWL As Int = iPeriodes(1) - iPeriodes(0) 'c";
_iwl = (int) (_iperiodes[(int) (1)]-_iperiodes[(int) (0)]);
 //BA.debugLineNum = 92;BA.debugLine="Dim iCorr As Int = modFreqAnalyser.GetCorrector";
_icorr = mostCurrent._modfreqanalyser._getcorrector(mostCurrent.activityBA,_sounddata,_ipos1,_ipos2,_iwl);
 //BA.debugLineNum = 93;BA.debugLine="Dim iK As Int = iPos2 - iPos1 + iCorr 'the dist";
_ik = (int) (_ipos2-_ipos1+_icorr);
 //BA.debugLineNum = 94;BA.debugLine="Dim iPerCount As Int = iBestComp - 1 'how many";
_ipercount = (int) (_ibestcomp-1);
 //BA.debugLineNum = 95;BA.debugLine="Dim dWL As Double = iK / iPerCount 'so we have";
_dwl = _ik/(double)_ipercount;
 //BA.debugLineNum = 96;BA.debugLine="Dim dFreq As Double = Round2(i_SampleRate / dWL";
_dfreq = anywheresoftware.b4a.keywords.Common.Round2(_i_samplerate/(double)_dwl,(int) (1));
 //BA.debugLineNum = 97;BA.debugLine="Dim iPitchNr As Int = modTuner.GetPichNr(dFreq)";
_ipitchnr = mostCurrent._modtuner._getpichnr(mostCurrent.activityBA,_dfreq);
 //BA.debugLineNum = 98;BA.debugLine="lblFreq.Text = dFreq & \" Hz\"";
mostCurrent._lblfreq.setText(BA.ObjectToCharSequence(BA.NumberToString(_dfreq)+" Hz"));
 //BA.debugLineNum = 99;BA.debugLine="lblPitch.Text = modTuner.GetPichname(iPitchNr)";
mostCurrent._lblpitch.setText(BA.ObjectToCharSequence(mostCurrent._modtuner._getpichname(mostCurrent.activityBA,_ipitchnr)));
 //BA.debugLineNum = 100;BA.debugLine="lblCent.Text = modTuner.GetFreqDiffInCent(modTu";
mostCurrent._lblcent.setText(BA.ObjectToCharSequence(mostCurrent._modtuner._getfreqdiffincent(mostCurrent.activityBA,mostCurrent._modtuner._getpitchfreq(mostCurrent.activityBA,_ipitchnr),mostCurrent._modtuner._equaloktave(mostCurrent.activityBA,_dfreq))));
 //BA.debugLineNum = 103;BA.debugLine="txtInfo.Text = iBestComp & \", \" & iPos1 & \", \"";
mostCurrent._txtinfo.setText(BA.ObjectToCharSequence(BA.NumberToString(_ibestcomp)+", "+BA.NumberToString(_ipos1)+", "+BA.NumberToString(_ipos2)+", "+BA.NumberToString(_icorr)+", "+BA.NumberToString(_ik)+", "+BA.NumberToString(_dfreq)+anywheresoftware.b4a.keywords.Common.CRLF+anywheresoftware.b4a.keywords.Common.CRLF+mostCurrent._modfreqanalyser._testgetperiodes(mostCurrent.activityBA,_iperiodes)));
 }else {
 //BA.debugLineNum = 107;BA.debugLine="txtInfo.Text = iBestComp & CRLF & modFreqAnalys";
mostCurrent._txtinfo.setText(BA.ObjectToCharSequence(BA.NumberToString(_ibestcomp)+anywheresoftware.b4a.keywords.Common.CRLF+mostCurrent._modfreqanalyser._testgetperiodes(mostCurrent.activityBA,_iperiodes)));
 };
 };
 //BA.debugLineNum = 110;BA.debugLine="End Sub";
return "";
}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 22;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 23;BA.debugLine="Private i_BufferSize As Int";
_i_buffersize = 0;
 //BA.debugLineNum = 24;BA.debugLine="Private i_SampleRate As Int";
_i_samplerate = 0;
 //BA.debugLineNum = 25;BA.debugLine="Private i_ChannelConfig As Int";
_i_channelconfig = 0;
 //BA.debugLineNum = 26;BA.debugLine="Private i_AudioFormat As Int";
_i_audioformat = 0;
 //BA.debugLineNum = 27;BA.debugLine="Private i_AudioSource As Int";
_i_audiosource = 0;
 //BA.debugLineNum = 29;BA.debugLine="Private AR As AudioRecord";
mostCurrent._ar = new stevel05.audiorecord.AudioRecording();
 //BA.debugLineNum = 31;BA.debugLine="Private btnRecord As Button";
mostCurrent._btnrecord = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 32;BA.debugLine="Private lblFreq As Label";
mostCurrent._lblfreq = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 33;BA.debugLine="Private txtInfo As EditText";
mostCurrent._txtinfo = new anywheresoftware.b4a.objects.EditTextWrapper();
 //BA.debugLineNum = 34;BA.debugLine="Private lblPitch As Label";
mostCurrent._lblpitch = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 35;BA.debugLine="Private spnAnalysers As Spinner";
mostCurrent._spnanalysers = new anywheresoftware.b4a.objects.SpinnerWrapper();
 //BA.debugLineNum = 36;BA.debugLine="Private lblCent As Label";
mostCurrent._lblcent = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 37;BA.debugLine="Private spnA As Spinner";
mostCurrent._spna = new anywheresoftware.b4a.objects.SpinnerWrapper();
 //BA.debugLineNum = 38;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
starter._process_globals();
modtuner._process_globals();
modfreqanalyser._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 18;BA.debugLine="Public tmrRecord As Timer";
_tmrrecord = new anywheresoftware.b4a.objects.Timer();
 //BA.debugLineNum = 19;BA.debugLine="Private b_busy As Boolean";
_b_busy = false;
 //BA.debugLineNum = 20;BA.debugLine="End Sub";
return "";
}
public static String  _record() throws Exception{
short[] _sound = null;
 //BA.debugLineNum = 67;BA.debugLine="Sub Record";
 //BA.debugLineNum = 68;BA.debugLine="If b_busy = True Then Return";
if (_b_busy==anywheresoftware.b4a.keywords.Common.True) { 
if (true) return "";};
 //BA.debugLineNum = 69;BA.debugLine="b_busy = True";
_b_busy = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 70;BA.debugLine="Dim sound(i_BufferSize) As Short";
_sound = new short[_i_buffersize];
;
 //BA.debugLineNum = 71;BA.debugLine="sound = AR.ReadShort(0, i_BufferSize)";
_sound = mostCurrent._ar.ReadShort((int) (0),_i_buffersize);
 //BA.debugLineNum = 74;BA.debugLine="Select spnAnalysers.SelectedIndex";
switch (BA.switchObjectToInt(mostCurrent._spnanalysers.getSelectedIndex(),(int) (0))) {
case 0: {
 //BA.debugLineNum = 76;BA.debugLine="FrequenceAnalyser1(sound)";
_frequenceanalyser1(_sound);
 break; }
}
;
 //BA.debugLineNum = 79;BA.debugLine="b_busy = False";
_b_busy = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 80;BA.debugLine="End Sub";
return "";
}
public static String  _spna_itemclick(int _position,Object _value) throws Exception{
int _ia = 0;
 //BA.debugLineNum = 134;BA.debugLine="Sub spnA_ItemClick (Position As Int, Value As Obje";
 //BA.debugLineNum = 135;BA.debugLine="Dim iA As Int = Value";
_ia = (int)(BA.ObjectToNumber(_value));
 //BA.debugLineNum = 136;BA.debugLine="modTuner.Init(iA)";
mostCurrent._modtuner._init(mostCurrent.activityBA,_ia);
 //BA.debugLineNum = 137;BA.debugLine="End Sub";
return "";
}
public static String  _tmrrecord_tick() throws Exception{
 //BA.debugLineNum = 113;BA.debugLine="Sub tmrRecord_Tick";
 //BA.debugLineNum = 114;BA.debugLine="Record";
_record();
 //BA.debugLineNum = 115;BA.debugLine="End Sub";
return "";
}
}
